VERSION 5.00
Begin VB.UserControl RadioGroup 
   ClientHeight    =   2880
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4050
   ScaleHeight     =   2880
   ScaleWidth      =   4050
   Begin VB.Frame Frame 
      Caption         =   "Frame"
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3735
      Begin VB.OptionButton Radio 
         Caption         =   "Option"
         Height          =   375
         Index           =   0
         Left            =   360
         TabIndex        =   1
         Top             =   360
         Visible         =   0   'False
         Width           =   1095
      End
   End
End
Attribute VB_Name = "RadioGroup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim M_Items As String
Dim A_Items() As String
Dim M_itemIndex As Integer
Dim ACount As Integer

Private Sub Radio_Click(Index As Integer)
M_itemIndex = Index
End Sub

Private Sub UserControl_Initialize()
 M_Items = ""
 M_itemIndex = -1
 ReDim A_Items(0) As String
  ACount = 0
  
 End Sub

Private Sub UserControl_InitProperties()
ReDim A_Items(0)
ACount = 0

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
 M_itemIndex = PropBag.ReadProperty("ItemIndex", -1)
 M_Items = PropBag.ReadProperty("Items", "")
 Frame.Caption = PropBag.ReadProperty("Caption", "")
 Set Frame.Font = PropBag.ReadProperty("FrameFont", Ambient.Font)
 Set RadioFont = PropBag.ReadProperty("RadioFont", Ambient.Font)
 
 Call Split(M_Items, A_Items, ";")
 UpdateRadios
 
End Sub

Private Sub UserControl_Resize()
 Frame.Width = UserControl.Width
 Frame.Height = UserControl.Height
 Frame.Top = 0
 Frame.Left = 0
 UpdateRadios
End Sub


Public Sub Clear()
M_Items = ""
ReDim A_Items(0) As String
ACount = 0
UpdateRadios
End Sub

Public Sub UpdateRadios()
Dim Ht As Integer
Dim RAdioHt As Integer
Dim Gaps As Integer
Dim cnt As Integer
Dim I As Integer
cnt = Radio.UBound
For I = 0 To cnt
Radio(I).Visible = False
Next
cnt = ACount
If cnt = 0 Then
  Exit Sub
End If
For I = 1 To cnt
If I <= Radio.UBound + 1 Then
  Radio(I - 1).Visible = True
  Radio(I - 1).Caption = A_Items(I - 1)
Radio(I - 1).Height = UserControl.TextHeight(Radio(I - 1).Caption) + 100
Radio(I - 1).Width = UserControl.TextWidth(Radio(I - 1).Caption) + 400

Else
  Load Radio(I - 1)
  Radio(I - 1).Visible = True
  Radio(I - 1).Caption = A_Items(I - 1)
Radio(I - 1).Height = UserControl.TextHeight(Radio(I - 1).Caption) + 100
Radio(I - 1).Width = UserControl.TextWidth(Radio(I - 1).Caption) + 400

 
End If
Next
RAdioHt = Radio(0).Height
Gaps = (Frame.Height - RAdioHt * ACount) / (ACount + 1)
For I = 1 To cnt
Radio(I - 1).Top = (Gaps * I) + RAdioHt * (I - 1)
Next

End Sub

Public Sub AddRadio(Acaption As String)
 If IsEmpty(M_Items) Then
     M_Items = Acaption
 Else
 
 M_Items = M_Items + ";" + Acaption
 End If
 
 Call Split(M_Items, A_Items, ";")
 
 UpdateRadios
End Sub

Public Property Get ItemIndex() As Integer
ItemIndex = M_itemIndex
End Property

Public Property Let ItemIndex(ByVal vNewValue As Integer)
If vNewValue > ACount - 1 Then
  Exit Property
End If
M_itemIndex = vNewValue
Radio(M_itemIndex).Value = True
PropertyChanged "ItemIndex"

End Property

Public Property Get Items() As String
  Dim s As String
  
  s = ""
  Items = M_Items
  
End Property

Public Property Let Items(ByVal vNewValue As String)
M_Items = vNewValue
Call Split(M_Items, A_Items, ";")


UpdateRadios
PropertyChanged "Items"
  
End Property


Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Call PropBag.WriteProperty("ItemIndex", M_itemIndex, -1)
Call PropBag.WriteProperty("Items", M_Items, "")
Call PropBag.WriteProperty("Caption", Frame.Caption, "")
Call PropBag.WriteProperty("FrameFont", Frame.Font, Ambient.Font)
Call PropBag.WriteProperty("RadioFont", Radio(0).Font, Ambient.Font)

End Sub

' SOUCE CODE FROM FREEVBCODE IT SELF

Public Function Split(ByVal Sin As String, sOut() As String, _
Optional sDelim As String, Optional nLimit As Long = -1, _
Optional bCompare As VbCompareMethod = vbBinaryCompare) As _
Variant
  
   Dim sRead As String, nC As Integer

   If sDelim = "" Then sDelim = " "
   ACount = 0
   If InStr(Sin, sDelim) = 0 Then
        ReDim sOut(0) As String
        sOut(0) = Sin
        Split = sOut
        ACount = 1
        Exit Function
   End If

   sRead = ReadUntil(Sin, sDelim, bCompare)

   Do
      ReDim Preserve sOut(nC)
      sOut(nC) = sRead
      nC = nC + 1
      If nLimit <> -1 And nC >= nLimit Then Exit Do
      sRead = ReadUntil(Sin, sDelim)
   Loop While sRead <> "~TWA"
   ReDim Preserve sOut(nC)
   sOut(nC) = Sin
   Split = sOut
   ACount = nC + 1
End Function

Private Function ReadUntil(ByRef Sin As String, sDelim As _
String, Optional bCompare As VbCompareMethod = _
vbBinaryCompare) As String
Dim nPos As String
nPos = InStr(1, Sin, sDelim, bCompare)
If nPos > 0 Then
   ReadUntil = Left(Sin, nPos - 1)
   Sin = Mid(Sin, nPos + Len(sDelim))
Else
   ReadUntil = "~TWA"
End If


End Function


Public Property Get Caption() As String
    Caption = Frame.Caption
End Property

Public Property Let Caption(ByVal vNewValue As String)

    Frame.Caption = vNewValue
 PropertyChanged "Caption"

End Property

Public Property Get FrameFont() As Font
  Set FrameFont = Frame.Font
  
End Property

Public Property Set FrameFont(ByVal vNewValue As Font)
  Set Frame.Font = vNewValue
PropertyChanged "FrameFont"

End Property

Public Property Get RadioFont() As Font
Set RadioFont = Radio(0).Font
End Property

Public Property Set RadioFont(ByVal vNewValue As Font)
Dim I As Integer
For I = 0 To Radio.UBound
 Set Radio(I).Font = vNewValue
Next
Set UserControl.Font = vNewValue
UpdateRadios
PropertyChanged "RadioFont"

End Property

Public Property Get SelectedItemCaption() As String
If ItemIndex > 0 Then
    SelectedItemCaption = Radio(ItemIndex).Caption
End If
End Property
